import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { Type } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasHighLowValueCategory } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { List$1 } from "igniteui-react-core";
import { Polyline } from "igniteui-react-core";
import { Polygon } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderSurface } from "./RenderSurface";
/**
 * @hidden
 */
export declare class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    j: RangeCategorySeriesView;
    constructor(a: RangeCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private l;
    private k;
    private i;
    private h;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RangeCategorySeries extends CategorySeries implements IIsCategoryBased, IHasHighLowValueCategory {
    static $t: Type;
    protected bp(): SeriesView;
    getHostReferenceValue(): number;
    kk(a: SeriesView): void;
    rl: RangeCategorySeriesView;
    constructor();
    private _RangeFramePreparer;
    RangeFramePreparer: RangeCategoryFramePreparer;
    ru: string;
    gt(a: any, b: string): any;
    lowColumn: IFastItemColumn$1<number>;
    private rn;
    rr: string;
    highColumn: IFastItemColumn$1<number>;
    private rm;
    protected p4(): CategoryTransitionInMode;
    rc(a: CategoryFrame, b: CategorySeriesView): void;
    protected rw(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    ap(a: Rect): AxisRange;
    dq(a: any): boolean;
    protected kp(a: any, b: string, c: any, d: any): void;
    ao(a: Axis): AxisRange;
    protected jo(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    ec(a: Rect, b: Rect, c: SeriesView): boolean;
    q9(a: CategoryFrame, b: CategorySeriesView): void;
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    provideCollisionDetector(): IDetectsCollisions;
    readonly mayContainUnknowns: boolean;
    k5(a: Rect, b: RenderSurface): void;
    private rj;
    k2(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    fa(): number;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RangeCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c0: RangeCategorySeries;
    constructor(a: RangeCategorySeries);
    c1(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    cs(): CategoryBucketCalculator;
}
